<?php
/**
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.4 $
 * $Author: tora60 $
 * $Date: 2009/05/15 11:03:38 $
 */

defined('mxMainFileLoaded') or die('access denied');

class pmxRestrictor {
    /* error-reporting abschalten und urspruenglichen Wert zwischenspeichern */
    private static $errorlevel = 0;

    /* die eigentliche Funktion */
    public static function start()
    {
        /* das Verzeichnis dieser Datei zwischenspeichern */
        $tempdir = dirname(__FILE__);

        /* error-reporting abschalten und urspruenglichen Wert zwischenspeichern */
        self::$errorlevel = error_reporting(0);

        /* wenn Konstante vorhanden, z.B. in backend.php nicht laden */
        if (defined('mxDontLoadPageRestritor')) {
            return self::close();
        }

        /* bei Admins nicht laden, es sei denn $pres wurde uebergeben */
        if (MX_IS_ADMIN && !isset($_GET['pres'])) {
            return self::close();
        }

        /* bei Usern auch nicht laden */
        if (MX_IS_USER && !MX_IS_ADMIN) {
            return self::close();
        }

        /* und wenn die pres-Datei fehlt, sowieso nicht ;) */
        if (!file_exists($tempdir . DS . 'page.restrictor.php')) {
            return self::close();
        }

        /* $pres nur bei Admins auswerten */
        if (!MX_IS_ADMIN) {
            unset($_GET['pres']);
        }

        /* Versionsinfo dieser Bridge ausgeben, zusammen mit normalen pres-Infos */
        if (MX_IS_ADMIN && isset($_GET['pres']) && $_GET['pres'] == 'check') {
            echo "<h3>pragmaMx Page Restrictor Plugin Version: " . self::version() . "</h3><pre>";
        }

        /* das aktuelle pragmaMx Verzeichnis zwischenspeichern */
        $temp_curdir = getcwd();
        if ($temp_curdir === false) {
            $temp_curdir = dirname($tempdir);
        } else {
            /* getcwd() kann auch mit backslash/slash am Ende kommen */
            $temp_curdir = rtrim($temp_curdir, DS . '/');
        }

        /* in das Verzeichnis dieser Datei wechseln */
        chdir($tempdir . DS);

        /* falls vorhanden, die Zentraldatei einbinden */
        include_once($tempdir . DS . 'bridge.settings.php');

        /* den Restrictor selbst einbinden */
        include_once($tempdir . DS . 'page.restrictor.php');

        /* in das pragmaMx Verzeichnis zurueckwechseln */
        chdir($temp_curdir . DS);

        /* check, ob wieder alles im Lot */
        if (!is_file('mainfile.php')) {
            die('<h2>Error</h2><p>Page Restrictor Plugin is not working correctly (chdir failed).<br />Please contact the pragmaMx <a href="http://www.pragmamx.org/Forum.html">Support Team</a>.<br /></p><p>To temporarly solve this error, rename the file /restrictor/bridge.php.</p>');
        }

        return self::close();
    }

    private static function close()
    {
        /* error-reporting auf urspruenglichen Wert zurueckstellen */
        error_reporting(self::$errorlevel);
    }

    private static function version()
    {
        @preg_match('#v ([0-9\.]{2,})\s([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})#', '$Id: bridge.php,v 1.4 2009/05/15 11:03:38 tora60 Exp $', $key);
        return "$key[1]/$key[2]-$key[3]-$key[4]";
    }
}

pmxRestrictor::start();

?>